import { MicroClient, PatternType } from "@ipare/micro";
import { MicroRedisClientOptions } from "./options";
import { MicroRedisConnection } from "./connection";
export declare class MicroRedisClient extends MicroClient {
    #private;
    protected readonly options: MicroRedisClientOptions;
    constructor(options?: MicroRedisClientOptions);
    connect(): Promise<void>;
    /**
     * for @ipare/inject
     */
    dispose(): Promise<void>;
    send<T = any>(pattern: PatternType, data: any): Promise<{
        data?: T;
        error?: string;
    }>;
    emit(pattern: PatternType, data: any): void;
}
export interface MicroRedisClient extends MicroRedisConnection<MicroRedisClientOptions> {
}
