"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockConnectionFrom = exports.mockConnection = exports.createMockRedis = void 0;
function createMockRedis() {
    const subscribes = {};
    return {
        subscribe: (channel, listener) => {
            subscribes[channel] = listener;
        },
        publish: (channel, data) => {
            subscribes[channel] && subscribes[channel](data);
        },
        connect() {
            this.isReady = true;
        },
        disconnect() {
            this.isReady = false;
        },
        isReady: true,
        isOpen: true,
    };
}
exports.createMockRedis = createMockRedis;
function mockConnection() {
    this.initClients = function () {
        return __awaiter(this, void 0, void 0, function* () {
            const redis = createMockRedis();
            this.pub = redis;
            this.sub = redis;
            redis.connect();
        });
    };
    return this;
}
exports.mockConnection = mockConnection;
function mockConnectionFrom(target) {
    this.initClients = function () {
        return __awaiter(this, void 0, void 0, function* () {
            this.pub = target.pub;
            this.sub = target.sub;
        });
    };
    return this;
}
exports.mockConnectionFrom = mockConnectionFrom;
